﻿var Conference = Conference || {};

Conference.Sessions = function ($, kendo) {
    var _sessions,
        _initialized = false;

    var init = function () {
        if (!_initialized) {
            _sessions = Conference.Data.sessions();
            var groups = group(_sessions);

            displayGroups(groups);

            _initialized = true;
        }
    };

    var group = function (sessions) {
        return Enumerable.From(sessions)
            .GroupBy(function (session) { return session.time; },
                        function (session) {
                            return {
                                id: session.id,
                                track: session.track,
                                title: session.title
                            };
                        },
                    function (time, grouping) {
                        return {
                            time: time,
                            sessions: grouping.ToArray()
                        };
                    })
            .ToArray();
    };

    var displayGroups = function (groups) {
        var template = kendo.template($("#sessionListGroup").html()),
            $sessionList = $("#sessionList");

        $sessionList.empty();

        for (var idx = 0; idx < groups.length; idx++) {
            $sessionList.append(template(groups[idx]));
        }
    };

    return {
        init: init,
        sessions: function () { return _sessions; }
    };
}(kendo.jQuery, kendo);
